unit mainf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, VideoCap, ExtCtrls,inifiles, StdCtrls, ComCtrls, Buttons,vfw,mmsystem;

type
  TMain = class(TForm)
    MainMenu1: TMainMenu;
    Datein1: TMenuItem;
    Beenden1: TMenuItem;
    Einstellungen1: TMenuItem;
    VideoTreiber1: TMenuItem;
    Panel1: TPanel;
    VideoCap1: TVideoCap;
    GroupBox1: TGroupBox;
    CheckPrev: TCheckBox;
    CheckOverl: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    fps: TLabel;
    N1: TMenuItem;
    VideoQuelle1: TMenuItem;
    VideoFormat1: TMenuItem;
    VideoAnzeige1: TMenuItem;
    VideoKompession1: TMenuItem;
    CheckSkale: TCheckBox;
    Checkprop: TCheckBox;
    GroupBox2: TGroupBox;
    BtSPict: TButton;
    Button2: TButton;
    EditSPict: TEdit;
    GroupBox4: TGroupBox;
    BtStartStop: TBitBtn;
    StatusBar1: TStatusBar;
    BtnPara: TBitBtn;
    EdFile: TEdit;
    SaveDialog1: TSaveDialog;
    Aufzeichnungsparameter1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    procedure VideoTreiber1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Video1Status(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckPrevClick(Sender: TObject);
    procedure CheckOverlClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure VideoFormat1Click(Sender: TObject);
    procedure VideoQuelle1Click(Sender: TObject);
    procedure VideoAnzeige1Click(Sender: TObject);
    procedure VideoKompession1Click(Sender: TObject);
    procedure CheckSkaleClick(Sender: TObject);
    procedure CheckpropClick(Sender: TObject);
    procedure BtSPictClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Video1StatusCallback(Sender: TObject; nID: Integer;
      status: String);
    procedure BtStartStopClick(Sender: TObject);
    procedure EditSPictDblClick(Sender: TObject);
    procedure EdFileDblClick(Sender: TObject);
    procedure Aufzeichnungsparameter1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure VideoCap1Error(sender: TObject; nID: Integer;
      errorstr: String);
    procedure Button1Click(Sender: TObject);
  private
   procedure updateBtn(stat:Boolean);
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Main: TMain;

implementation

uses DlgTreiber, dlgaufz, aboutx;

{$R *.DFM}

procedure TMain.VideoTreiber1Click(Sender: TObject);
Var DrvList:TStrings;
begin
 DlgEinstell:=TDlgEinstell.Create(Self);
 drvList:=  GetDriverList;
 dlgEinstell.Combobox1.Items:= drvList;
 VideoCap1.DriverOpen:= false;
 dlgEinstell.ComboBox1.Itemindex:= VideoCap1.DriverIndex;
 if DlgEinstell.ShowModal = mrOK then
    begin
      videoCap1.DriverIndex:= dlgEinstell.combobox1.ItemIndex;
    end;

 VideoCap1.DriverOpen:= true;
 DlgEinstell.Free;
 drvList.Clear;
 drvList.Free;
end;

procedure TMain.FormCreate(Sender: TObject);
var ini:TInifile;

begin
 ini:= TInifile.Create('vcap.ini');
 VideoCap1.Driverindex:=ini.readInteger('Driver','index',-1);
 ini.free;
end;

procedure TMain.FormDestroy(Sender: TObject);
var ini:TInifile;

begin
 ini:= TInifile.Create('vcap.ini');
 ini.writeInteger('Driver','index',videoCap1.Driverindex);
 ini.free;
end;

procedure TMain.Video1StatusCallback(Sender: TObject; nID: Integer;
  status: String);
begin
  if nID =IDS_CAP_STAT_VIDEOCURRENT then exit;

  StatusBar1.Panels[0].Text:= status;

  if NId = IDS_CAP_End then
   begin
    UpDateBtn(False);
    if VideoCap1.BufferFileSize <> 0 then    // If we use a Bufferfile now save the frames to AVI-File
      VideoCap1.SaveCap;
  end;

  if nId = IDS_Cap_Begin then
    UpdateBtn(true);
    


end;


procedure TMain.Video1Status(Sender: TObject);
begin
if VideoCap1.DriverIndex= -1 then
 begin
   checkprev.enabled := false;
   videoKompession1.Enabled:= false;
  end
else
begin
 checkprev.enabled:= true;
 videoKompession1.enabled:= true;
end;

 Edit1.Text:= inttostr(VideoCap1.PreviewRate);
 checkOverl.Enabled:= VideoCap1.HasVideoOverlay;
 checkprev.Checked:=VideoCap1.VideoPreview;
 checkOverl.Checked:=VideoCap1.VideoOverlay;
 VideoFormat1.enabled:= VideoCap1.HasDlgFormat;
 VideoAnzeige1.Enabled:= VideoCap1.HasDlgDisplay;
 VideoQuelle1.Enabled:= VideoCap1.HasDlgSource;
end;

procedure TMain.FormShow(Sender: TObject);
begin
 VideoCap1.DriverOpen:=True;
 editsPict.text:= VideoCap1.SingleImageFile;
 edFile.Text:=VideoCap1.VideoFileName;
end;

procedure TMain.CheckPrevClick(Sender: TObject);
begin
 VideoCap1.VideoPreview:=CheckPrev.Checked;

end;

procedure TMain.CheckOverlClick(Sender: TObject);
begin
 VideoCap1.VideoOverlay:=CheckOverl.Checked;
end;

procedure TMain.Edit1Change(Sender: TObject);
var i:integer;
begin
try
 i:= strtoint(Edit1.Text);
 if (i > 0) and ( i < 30) then VideoCap1.PreviewRate:=i;
except
end;
end;

procedure TMain.VideoFormat1Click(Sender: TObject);
begin
 VideoCap1.DlgVFormat;
end;

procedure TMain.VideoQuelle1Click(Sender: TObject);
begin
 VideoCap1.DlgVSource;
end;

procedure TMain.VideoAnzeige1Click(Sender: TObject);
begin
 videoCap1.DlgVDisplay;
end;

procedure TMain.VideoKompession1Click(Sender: TObject);
begin
 videoCap1.DlgVCompression;
end;

procedure TMain.CheckSkaleClick(Sender: TObject);
begin
 videoCap1.PreviewScaleToWindow:=CheckSkale.Checked;
end;

procedure TMain.CheckpropClick(Sender: TObject);
begin
VideoCap1.PreviewScaleProportional:=Checkprop.Checked;
end;

procedure TMain.BtSPictClick(Sender: TObject);
begin
VideoCap1.SingleImageFile:= EditSPict.Text;
VideoCap1.GrabFrameNoStop;

if not VideoCap1.SaveAsDib then
 MessageDlg('Could not save picture',mtError,[mbOK],0)
else
 MessageDlg('Picture saved',mtInformation,[mbOK],0);
end;


procedure TMain.Button2Click(Sender: TObject);
begin
 VideoCap1.GrabFrameNoStop;
 VideoCap1.SaveToClipboard;
end;


procedure TMain.BtStartStopClick(Sender: TObject);
begin
 if VideoCap1.CapInProgess then
 begin
  VideoCap1.StopCapture ;
  end
 else
 begin
    VideoCap1.VideoFileName:= edFile.Text;
    VideoCap1.StartCapture;
 end;

end;

procedure TMain.UpdateBtn(stat:boolean);

begin

if stat then
  begin
    BtStartStop.caption:= 'Stop';
    btStartStop.Font.Color:= clgreen;
  end
  else
   begin
    BtStartStop.caption:= 'Start';
    btStartStop.Font.Color:= clred;
  end;
 end;



procedure TMain.EditSPictDblClick(Sender: TObject);
begin
 SaveDialog1.Filter:='Bitmaps (*.bmp)|*.bmp';
 SaveDialog1.FileName:= editspict.text;
 if SaveDialog1.Execute then
  editspict.Text:=saveDialog1.filename;
end;

procedure TMain.EdFileDblClick(Sender: TObject);
begin
  SaveDialog1.Filter:='Avi-Files (*.avi)|*.avi';
  SaveDialog1.FileName:= edfile.text;
  if saveDialog1.Execute then
   edFile.text:= saveDialog1.FileName;
end;

procedure TMain.Aufzeichnungsparameter1Click(Sender: TObject);
begin
dlgVpara:=TDlgVPara.Create(Self);
DlgVPara.ShowModal;
dlgvpara.Free;
end;

procedure TMain.Beenden1Click(Sender: TObject);
begin
Close;
end;

procedure TMain.About1Click(Sender: TObject);
begin
 AboutDlg:= TAboutDlg.Create(self);
 AboutDlg.ShowModal;
 AboutDlg.Free;
end;

procedure TMain.VideoCap1Error(sender: TObject; nID: Integer;
  errorstr: String);
begin
   StatusBar1.Panels[1].Text:= errorstr;
end;

procedure TMain.Button1Click(Sender: TObject);
begin
 VideoCap1.SaveCap;
end;

end.
